*c99 m-optimizer v1.1/g
*c99 f-optimizer v1.3/g
 REF FARG#1,FARG#2,FARG#3,FARG#4,FARG#5,FARG#6,FARG#7,FARG#8
*c99 x-optimizer v1.4/g
 REF XPOLL,XGETS,XPUTC,XPUTS,XDPUTS
 REF XLOCAT,XTSCRN
 REF XMSET,XMMOV,XMCPY,XSLEN,XSCHR
 REF XSCAT,XSCPY,XSNCPY,XSCMP,XSNCMP
 REF XVWTR,XVSBW,XVMBR,XVMBW
*c99 optimizer v4.5/g
*c99 v4.0 (c) 1985, 1987 Clint Pulley
 REF C$CIND,C$DIV,C$REM,C$ASR,C$ASL,C$EQ,C$NE,C$LT,C$LE
 REF C$GT,C$GE,C$ULT,C$ULE,C$UGT,C$UGE,C$LNEG,C$SWCH
 REF GETCHA,GETS,PUTCHA,PUTS,LOCATE,POLL,TSCRN,EXIT,C$CALL
*/*
* * PICALC1 V1.0 09/08/2007
* *
* * F.G.Kaal
* * De Dadelboom 81
* * 1911 KK Uitgeest
* *
* * Adapted from the Extended basic program
* * PiCalc by Walid Maalouli
* *
* * Remarks:
* * 1)Number of decimals that fit in a 32bit number is
* *   INT( LOG(SQR(2^31)) / LOG(10)) = 4
* *
* * 2)TI/EX Basic INT() function:
* *   INT(3.2)=3, INT(-3.2)=-4, INT(-0.2)=-1
* *
* * 3) Some magic numbers explained
* *    Number of decimals per long value is 4
* *    Therefore max number of decimals is 4*arraysize-2*4
* *    =4*652-8=2600
* *    PI=16*ATAN(1/5) - 4*ATAN(1/239)
* *    1/5 = 0.2000, the number 2000 is exactly that in 4 decimals
* *    25=5^2 and 57121=239^2
* * 
* */
*#include ".\..\TILIB\CGLOB_H"
*/*
* * cglob_h
* *
* * These are the multipurpose global variables for C99C
* */
*
*extern errno, cnull;
 REF ERRNO
 REF CNULL
*
*
*#include ".\..\TILIB\MISC_H"
*/* Functions in MISC */
*extern memset(),memmove(),memcpy(),memcmp();
 REF MEMSET
 REF MEMMOV
 REF MEMCPY
 REF MEMCMP
*extern strcpy(),strncpy(),strlen(),strcat();
 REF STRCPY
 REF STRNCP
 REF STRLEN
 REF STRCAT
*extern strcmp(),strncmp(),strchr();
 REF STRCMP
 REF STRNCM
 REF STRCHR
*
*#include ".\..\TILIB\CONV_H"
*/* CONV */
*
*extern xtol(),xtoi(),xctoi(),atol(),atoi();
 REF XTOL
 REF XTOI
 REF XCTOI
 REF ATOL
 REF ATOI
*
*
*#include ".\..\TILIB\CTYPE_H"
*extern isalpha(),isupper(),islower(),isdigit(),isxdigit();
 REF ISALPH
 REF ISUPPE
 REF ISLOWE
 REF ISDIGI
 REF ISXDIG
*extern isspace(),iscntrl(),ispunct(),isalnum(),isprint();
 REF ISSPAC
 REF ISCNTR
 REF ISPUNC
 REF ISALNU
 REF ISPRIN
*extern isgraph(),toupper(),tolower(),ctype();
 REF ISGRAP
 REF TOUPPE
 REF TOLOWE
 REF CTYPE
*
*/* types to use with getyxts() */
*
*#define CT_CNTRL  0x0001  /* 0-31 127 */
*#define CT_SPACE  0x0002  /* ' ' '\t' '\v' '\f' '\r' '\n' */
*#define CT_PUNCT  0x0004  /* not upper,lower,digit,xdigit,space */
*#define CT_UPPER  0x0008  /* 'A'-'Z' */
*#define CT_LOWER  0x0010  /* 'a'-'z' */
*#define CT_ALPHA  0x0018  /* upper | lower */
*#define CT_ALNUM  0x0038  /* upper | lower | digit */
*#define CT_DIGIT  0x0020  /* '0'-'9' */
*#define CT_XDIGIT 0x0040  /* '0'-'9' | 'a'-'f' | 'A'-'F' */
*#define CT_PRINT  0x0080  /* ' '-'~' */
*#define CT_GRAPH  0x003C  /* alpha | digit | punct */
*#define LT_PRINT  0x0080  /* tolower(isprint())  in getyxts() */
*#define LT_GRAPH  0x403C  /* tolower(isgraph())  in getyxts() */
*#define LT_XDIGIT 0x4040  /* tolower(isxdigit()) in getyxts() */
*#define UT_PRINT  0x0080  /* toupper(isprint())  in getyxts() */
*#define UT_GRAPH  0x803C  /* toupper(isgraph())  in getyxts() */
*#define UT_XDIGIT 0x8040  /* toupper(isxdigit()) in getyxts() */
*
*#include ".\..\TILIB\LONG_H"
*/* LONG */
*
*extern lclr(),  lseto(),linc(), ldec(), linv(),labs(),lneg();
 REF LCLR
 REF LSETO
 REF LINC
 REF LDEC
 REF LINV
 REF LABS
 REF LNEG
*extern lcpys(), lcpyl(),lcmpl(),ltst();
 REF LCPYS
 REF LCPYL
 REF LCMPL
 REF LTST
*extern landl(), lorl(), lxorl(),lshls(),lshrs();
 REF LANDL
 REF LORL
 REF LXORL
 REF LSHLS
 REF LSHRS
*extern ladds(), laddl(),lsubs(),lsubl();
 REF LADDS
 REF LADDL
 REF LSUBS
 REF LSUBL
*extern lmpys(), lmpyl();
 REF LMPYS
 REF LMPYL
*extern  sldivs(),ldivs(),lmods(),ldivl(),lmodl();
 REF SLDIVS
 REF LDIVS
 REF LMODS
 REF LDIVL
 REF LMODL
*#include ".\..\TILIB\SPRINTF_H"
*extern dprintf(),printf(),sprintf();
 REF DPRINT
 REF PRINTF
 REF SPRINT
*#include "PICALC_H"
*/*
* * PICALC_H  V1.0 09/08/2007
* *
* * F.G.Kaal
* * De Dadelboom 81
* * 1911 KK Uitgeest
* *
* * Externals, Variables and definitions
* */
*
*#asm
 REF VDPWD,VSBW,VMBW,VSBR,VMBR
 REF GRMRA,GRMWA
 REF THSCRU,LSTCRU
 REF C$VADR,S$LOC
*
*#define MAXLINE 81
*#define MAXPATH 50
*
*extern int  KBARDL,KBARSP;
 REF KBARDL
 REF KBARSP
*
*extern getyxts(),getkey(),waitkey(),clearw();
 REF GETYXT
 REF GETKEY
 REF WAITKE
 REF CLEARW
*
*entry SUM,SUM1,TERM,TEMP;
 DEF SUM
 DEF SUM1
 DEF TERM
 DEF TEMP
*
*#define SIGNED 1 /* SIGNED OR UNSIGNED MPY AND DIV */
*
*#ifdef SIGNED
*#define LMPY lsmpyl
*#define LDIV lsdivl
*#endif
*
*#ifdef UNSIGNED
*#define LMPY lmpyl
*#define LDIV ldivl
*#endif
*
*#define LONGSIZE 4
*#define ARRSIZE  652
*
*char inpline[40];
INPLIN BSS 40
 EVEN
*int N,I,D,S,ITR,DENOM1,TBASE,MULT,FLAG;
N BSS 2
I BSS 2
D BSS 2
S BSS 2
ITR BSS 2
DENOM1 BSS 2
TBASE BSS 2
MULT BSS 2
FLAG BSS 2
*int CPYBYTES;
CPYBYT BSS 2
*
*/* long variables */
*int L10000[2]  = {0x0000, 0x2710};
L10000
 DATA 0,10000
*int L0[2]      = {0x0000, 0x0000};
L0
 DATA 0,0
*
*int SUM[ARRSIZE][2],SUM1[ARRSIZE][2];
SUM BSS 2608
SUM1 BSS 2608
*int TERM[ARRSIZE][2],TEMP[ARRSIZE][2];
TERM BSS 2608
TEMP BSS 2608
*
*int lval[2]; 
LVAL BSS 4
*int DIVIDEND[2], REMAINDER[2], LDENOM[2];
DIVIDE BSS 4
REMAIN BSS 4
LDENOM BSS 4
*int QUOTIENT[2];
QUOTIE BSS 4
*char *lp1,*lp2;
LP1 DATA 0
 EVEN
LP2 DATA 0
 EVEN
*
*main()
 DEF MAIN
MAIN
*{
*    locate(1,8); puts("Pi Calculator");
 LI 1,1
 LI 0,8
 BL *12
 DATA XLOCAT
 LI 5,C$3
 BL *12
 DATA XPUTS
*    locate(3,8); puts("By Walid Maalouli");
 LI 1,3
 LI 0,8
 BL *12
 DATA XLOCAT
 LI 5,C$3+14
 BL *12
 DATA XPUTS
*    locate(5,8); puts("August 2007");
 LI 1,5
 LI 0,8
 BL *12
 DATA XLOCAT
 LI 5,C$3+32
 BL *12
 DATA XPUTS
*    locate(7,8); puts("Converted to C99");
 LI 1,7
 LI 0,8
 BL *12
 DATA XLOCAT
 LI 5,C$3+44
 BL *12
 DATA XPUTS
*    locate(9,8); puts("By Fred G. Kaal");
 LI 1,9
 LI 0,8
 BL *12
 DATA XLOCAT
 LI 5,C$3+61
 BL *12
 DATA XPUTS
*
*    memset(SUM ,0,ARRSIZE*LONGSIZE);
 LI 8,SUM
 BL 15
 S 8,8
 BL 15
 LI 8,652
 BL 15
 LI 8,4
 MPY *14+,8
 MOV 9,8
 BL 15
 BL *12
 DATA MEMSET
 AI 14,6
*    memset(SUM1,0,ARRSIZE*LONGSIZE);
 LI 8,SUM1
 BL 15
 S 8,8
 BL 15
 LI 8,652
 BL 15
 LI 8,4
 MPY *14+,8
 MOV 9,8
 BL 15
 BL *12
 DATA MEMSET
 AI 14,6
*    memset(TERM,0,ARRSIZE*LONGSIZE);
 LI 8,TERM
 BL 15
 S 8,8
 BL 15
 LI 8,652
 BL 15
 LI 8,4
 MPY *14+,8
 MOV 9,8
 BL 15
 BL *12
 DATA MEMSET
 AI 14,6
*    memset(TEMP,0,ARRSIZE*LONGSIZE);
 LI 8,TEMP
 BL 15
 S 8,8
 BL 15
 LI 8,652
 BL 15
 LI 8,4
 MPY *14+,8
 MOV 9,8
 BL 15
 BL *12
 DATA MEMSET
 AI 14,6
*    do
C$6
*    {
*        locate(12,2);  puts("# of decimals (mult. of 4)");
 LI 1,12
 LI 0,2
 BL *12
 DATA XLOCAT
 LI 5,C$3+77
 BL *12
 DATA XPUTS
*        locate(13,2);  puts("(Maximum of 2600 decimals)");
 LI 1,13
 LI 0,2
 BL *12
 DATA XLOCAT
 LI 5,C$3+104
 BL *12
 DATA XPUTS
*        getyxts(14,12,CT_DIGIT,4,inpline);
 LI 4,14
 LI 5,12
 LI 6,32
 LI 7,4
 LI 8,INPLIN
 BL @FARG#5
 DATA GETYXT
 AI 14,10
*        D=atoi(inpline);
 LI 8,INPLIN
 BL *12
 DATA ATOI
 MOV 8,@D
*    }
*    while ((D<=0) || (D>2600) || (D%4!=0));
C$4
 MOV @D,8
 CI 8,0
 JLT C$7
 JEQ C$7
 MOV @D,8
 CI 8,2600
 JGT C$7
 MOV @D,8
 BL 15
 LI 8,4
 BL @C$REM
 CI 8,0
 JEQ C$5
C$7
 B @C$6
C$5
*
*/*160 ITR=INT(D/1.4) :: D=D/5+2 */
*    ITR=(D*10)/14+1; D=D/4+2;
 MOV @D,8
 BL 15
 LI 8,10
 MPY *14+,8
 MOV 9,8
 BL 15
 LI 8,14
 BL @C$DIV
 AI 8,1
 MOV 8,@ITR
 MOV @D,8
 BL 15
 LI 8,4
 BL @C$DIV
 AI 8,2
 MOV 8,@D
*
*/*170 SUM(1)=3 :: SUM(2)=20000 :: TERM(1)=0 :: TERM(2)=20000 
*  :: S=0 :: DENOM1=3 :: TBASE=25 :: MULT=16*/
*
*    lcpys(&SUM[1][0],3);  lcpys(&SUM[2][0],2000);
 LI 8,SUM
 BL 15
 LI 8,1
 LI 7,2
 MPY 8,7
 A 8,8
 A *14+,8
 BL 15
 LI 8,3
 BL @FARG#1
 DATA LCPYS
 AI 14,4
 LI 8,SUM
 BL 15
 LI 8,2
 LI 7,2
 MPY 8,7
 A 8,8
 A *14+,8
 BL 15
 LI 8,2000
 BL @FARG#1
 DATA LCPYS
 AI 14,4
*    lcpys(&TERM[1][0],0); lcpys(&TERM[2][0],2000);
 LI 8,TERM
 BL 15
 LI 8,1
 LI 7,2
 MPY 8,7
 A 8,8
 A *14+,8
 BL 15
 S 8,8
 BL @FARG#1
 DATA LCPYS
 AI 14,4
 LI 8,TERM
 BL 15
 LI 8,2
 LI 7,2
 MPY 8,7
 A 8,8
 A *14+,8
 BL 15
 LI 8,2000
 BL @FARG#1
 DATA LCPYS
 AI 14,4
*
*    CPYBYTES=D*LONGSIZE+LONGSIZE; /* Array size in bytes */
 MOV @D,8
 BL 15
 LI 8,4
 MPY *14+,8
 MOV 9,8
 AI 8,4
 MOV 8,@CPYBYT
*
*    CalcPi();
 BL *12
 DATA CALCPI
*    OutScreen();
 BL *12
 DATA OUTSCR
*    
*    exit(0);
 S 8,8
 BL @FARG#1
 DATA EXIT
 INCT 14
*}
 B *13
C$3 BYTE 80,105,32,67,97,108,99,117,108,97,116,111
 BYTE 114,0,66,121,32,87,97,108,105,100,32,77
 BYTE 97,97,108,111,117,108,105,0,65,117,103,117
 BYTE 115,116,32,50,48,48,55,0,67,111,110,118
 BYTE 101,114,116,101,100,32,116,111,32,67,57,57
 BYTE 0,66,121,32,70,114,101,100,32,71,46,32
 BYTE 75,97,97,108,0,35,32,111,102,32,100,101
 BYTE 99,105,109,97,108,115,32,40,109,117,108,116
 BYTE 46,32,111,102,32,52,41,0,40,77,97,120
 BYTE 105,109,117,109,32,111,102,32,50,54,48,48
 BYTE 32,100,101,99,105,109,97,108,115,41,0
 EVEN
*
*CalcPi()
CALCPI
*{
*/*170*/ DENOM1=3; TBASE=25; MULT=16; FLAG=0;
 LI 8,3
 MOV 8,@DENOM1
 LI 8,25
 MOV 8,@TBASE
 LI 8,16
 MOV 8,@MULT
 S 8,8
 MOV 8,@FLAG
*/*180*/ Iterate();
 BL *12
 DATA ITERAT
*
*/*460 IF FLAG=1 THEN 620*/
*/*470*/ DENOM1=3; TBASE=57121; MULT=4;
 LI 8,3
 MOV 8,@DENOM1
 LI 8,57121
 MOV 8,@TBASE
 LI 8,4
 MOV 8,@MULT
*            
*/*480 FOR I=1 TO D*/
*/*490 SUM1(I)=SUM(I)*/
*/*500 SUM(I)=0 :: TERM(I)=0*/
*/*510 NEXT I*/
*    memcpy(SUM1,SUM,CPYBYTES);
 LI 0,SUM1
 LI 1,SUM
 MOV @CPYBYT,2
 BL *12
 DATA XMCPY
*    memset(SUM,  0, CPYBYTES);
 LI 6,SUM
 S 7,7
 MOV @CPYBYT,8
 BL @FARG#3
 DATA MEMSET
 AI 14,6
*    memset(TERM, 0, CPYBYTES);
 LI 6,TERM
 S 7,7
 MOV @CPYBYT,8
 BL @FARG#3
 DATA MEMSET
 AI 14,6
*
*/*520 TERM(1)=4*/
*    lcpys(&TERM[1][0],4);
 LI 8,TERM
 BL 15
 LI 8,1
 LI 7,2
 MPY 8,7
 A 8,8
 A *14+,8
 BL 15
 LI 8,4
 BL @FARG#1
 DATA LCPYS
 AI 14,4
*
*/*530 DENOM=239 :: REMAINDER=0*/
*/*540 GOSUB 1050*/
*    SubDivide(239);
 LI 8,239
 BL @FARG#1
 DATA SUBDIV
 INCT 14
*
*/*550 FOR I=1 TO D*/
*/*560 SUM(I)=TERM(I) :: TERM(I)=0*/
*/*570 NEXT I*/
*    memcpy(SUM,TERM,CPYBYTES);
 LI 0,SUM
 LI 1,TERM
 MOV @CPYBYT,2
 BL *12
 DATA XMCPY
*    memset(TERM, 0, CPYBYTES);
 LI 6,TERM
 S 7,7
 MOV @CPYBYT,8
 BL @FARG#3
 DATA MEMSET
 AI 14,6
*
*/*580 DENOM=239 :: TERM(1)=1 :: REMAINDER=0*/
*/*590 GOSUB 1050*/
*    lcpys(&TERM[1][0],1);
 LI 8,TERM
 BL 15
 LI 8,1
 LI 7,2
 MPY 8,7
 A 8,8
 A *14+,8
 BL 15
 LI 8,1
 BL @FARG#1
 DATA LCPYS
 AI 14,4
*    SubDivide(239);
 LI 8,239
 BL @FARG#1
 DATA SUBDIV
 INCT 14
*
*/*600 FLAG=1 :: S=0*/
*/*610 GOTO 180*/
*    Iterate();
 BL *12
 DATA ITERAT
*
*/*620 PRINT :: PRINT "Finalizing calculations..." :: PRINT*/
*    puts("\nFinalizing calculations...\n\n");
 LI 5,C$8
 BL *12
 DATA XPUTS
*
*/*630 FOR I=1 TO D*/
*    lp1=&SUM[1][0]; lp2=&SUM1[1][0];
 LI 8,SUM
 BL 15
 LI 8,1
 LI 7,2
 MPY 8,7
 A 8,8
 A *14+,8
 MOV 8,@LP1
 LI 8,SUM1
 BL 15
 LI 8,1
 LI 7,2
 MPY 8,7
 A 8,8
 A *14+,8
 MOV 8,@LP2
*    for (I=1; I<=D; ++I)
 LI 8,1
 MOV 8,@I
C$11
 MOV @I,8
 C 8,@D
 JLT $+8
 JEQ $+6
 B @C$10
 B @C$12
C$9
 INC @I
 MOV @I,8
 B @C$11
C$12
*    {
*/*640 SUM1(I)=SUM1(I)-SUM(I) :: SUM(I)=SUM1(I)*/
*        lsubl(lp2,lp1); lcpyl(lp1,lp2);
 MOV @LP2,7
 MOV @LP1,8
 BL @FARG#2
 DATA LSUBL
 AI 14,4
 MOV @LP1,7
 MOV @LP2,8
 BL @FARG#2
 DATA LCPYL
 AI 14,4
*        lp1=lp1+LONGSIZE; lp2=lp2+LONGSIZE;
 MOV @LP1,8
 AI 8,4
 MOV 8,@LP1
 MOV @LP2,8
 AI 8,4
 MOV 8,@LP2
*/*650 NEXT I*/
*    }
 B @C$9
C$10
*
*/*660 FLAG=2*/
*/*670 GOTO 330*/
*    DoCarry();
 BL *12
 DATA DOCARR
*/*680 ready!*/
*}
 B *13
C$8 BYTE 10,70,105,110,97,108,105,122,105,110,103,32
 BYTE 99,97,108,99,117,108,97,116,105,111,110,115
 BYTE 46,46,46,10,10,0
 EVEN
*
*Iterate()
ITERAT
*{
*    FLAG=FLAG+1; S=0;
 MOV @FLAG,8
 AI 8,1
 MOV 8,@FLAG
 S 8,8
 MOV 8,@S
*   
*/*180 FOR N=1 TO ITR+1*/
*    for (N=1; N<=ITR; ++N)
 LI 8,1
 MOV 8,@N
C$16
 MOV @N,8
 C 8,@ITR
 JLT $+8
 JEQ $+6
 B @C$15
 B @C$17
C$14
 INC @N
 MOV @N,8
 B @C$16
C$17
*    {
*/*190 IF FLAG=0 THEN PRINT "Term 1 iteration #";N ELSE PRINT "Term 2 iteration 




*#";N*/
*        printf("Term %u iteration #%u\n", FLAG, N);
 LI 6,C$13
 MOV @FLAG,7
 MOV @N,8
 BL @FARG#3
 DATA PRINTF
 AI 14,6
*
*/*200 IF N=1 THEN 220*/
*/*210 FOR I=1 TO D :: TERM(I)=TEMP(I) :: NEXT I*/
*        if (N!=1) memcpy(TERM, TEMP, CPYBYTES);
 MOV @N,8
 CI 8,1
 JEQ C$18
 LI 0,TERM
 LI 1,TEMP
 MOV @CPYBYT,2
 BL *12
 DATA XMCPY
*            
*/*220 DENOM=TBASE :: REMAINDER=0*/
*/*230 GOSUB 1050*/
*        SubDivide(TBASE);
C$18
 MOV @TBASE,8
 BL @FARG#1
 DATA SUBDIV
 INCT 14
*
*/*240 FOR I=1 TO D :: TEMP(I)=TERM(I) :: NEXT I*/
*        memcpy(TEMP, TERM, CPYBYTES);
 LI 0,TEMP
 LI 1,TERM
 MOV @CPYBYT,2
 BL *12
 DATA XMCPY
*
*/*250 DENOM=DENOM1 :: REMAINDER=0*/
*/*260 GOSUB 1050*/
*        SubDivide(DENOM1);
 MOV @DENOM1,8
 BL @FARG#1
 DATA SUBDIV
 INCT 14
*
*/*270 FOR I=1 TO D*/
*        lp1=&SUM[1][0]; lp2=&TERM[1][0];
 LI 8,SUM
 BL 15
 LI 8,1
 LI 7,2
 MPY 8,7
 A 8,8
 A *14+,8
 MOV 8,@LP1
 LI 8,TERM
 BL 15
 LI 8,1
 LI 7,2
 MPY 8,7
 A 8,8
 A *14+,8
 MOV 8,@LP2
*        for (I=1; I<=D; ++I)
 LI 8,1
 MOV 8,@I
C$21
 MOV @I,8
 C 8,@D
 JLT $+8
 JEQ $+6
 B @C$20
 B @C$22
C$19
 INC @I
 MOV @I,8
 B @C$21
C$22
*        {
*/*280 IF S=0 THEN 300*/
*            lcpys(lval,MULT);
 LI 7,LVAL
 MOV @MULT,8
 BL @FARG#2
 DATA LCPYS
 AI 14,4
*            LMPY(lval,lp2);
 LI 7,LVAL
 MOV @LP2,8
 BL @FARG#2
 DATA LSMPYL
 AI 14,4
*            if (S!=0)
 MOV @S,8
 CI 8,0
 JEQ C$23
*            {
*/*290 SUM(I)=SUM(I)+MULT*TERM(I) :: GOTO 310*/
*                laddl(lp1,lval);
 MOV @LP1,7
 LI 8,LVAL
 BL @FARG#2
 DATA LADDL
 AI 14,4
*            }
*            else
 B @C$24
C$23
*            {
*/*300 SUM(I)=SUM(I)-MULT*TERM(I)*/
*                lsubl(lp1,lval);
 MOV @LP1,7
 LI 8,LVAL
 BL @FARG#2
 DATA LSUBL
 AI 14,4
*            }
C$24
*            lp1=lp1+LONGSIZE; lp2=lp2+LONGSIZE;
 MOV @LP1,8
 AI 8,4
 MOV 8,@LP1
 MOV @LP2,8
 AI 8,4
 MOV 8,@LP2
*/*310 NEXT I*/
*        }
 B @C$19
C$20
*
*/*320 IF S=0 THEN S=1 ELSE S=0*/
*        S = (S==0) ? 1 : 0;
 MOV @S,8
 CI 8,0
 JNE C$25
 LI 8,1
 B @C$26
C$25
 S 8,8
C$26
 MOV 8,@S
*/*330*/
*        DoCarry();
 BL *12
 DATA DOCARR
*
*/*440 DENOM1=DENOM1+2*/
*        DENOM1=DENOM1+2;
 MOV @DENOM1,8
 AI 8,2
 MOV 8,@DENOM1
*/*450 NEXT N*/
*/*Out();*/
*    }
 B @C$14
C$15
*}
 B *13
C$13 BYTE 84,101,114,109,32,37,117,32,105,116,101,114
 BYTE 97,116,105,111,110,32,35,37,117,10,0
 EVEN
*
*/* Check values of SUM[] */
*
*DoCarry()
DOCARR
*{
*/*330 FOR I=D TO 2 STEP-1*/
*    lp1=&SUM[D][0]; lp2=&SUM[D-1][0];
 LI 8,SUM
 BL 15
 MOV @D,8
 LI 7,2
 MPY 8,7
 A 8,8
 A *14+,8
 MOV 8,@LP1
 LI 8,SUM
 BL 15
 MOV @D,8
 AI 8,-1
 LI 7,2
 MPY 8,7
 A 8,8
 A *14+,8
 MOV 8,@LP2
*    for(I=D; I>=2; --I)
 MOV @D,8
 MOV 8,@I
C$30
 MOV @I,8
 CI 8,2
 JGT $+8
 JEQ $+6
 B @C$29
 B @C$31
C$28
 DEC @I
 MOV @I,8
 B @C$30
C$31
*    {
*/*340 IF SUM(I)==0 420*/
*        if (ltst(lp1)!=0)
 MOV @LP1,8
 BL @FARG#1
 DATA LTST
 INCT 14
 CI 8,0
 JNE $+6
 B @C$32
*        {
*/*350 QUOTIENT=INT(SUM(I)/100000)*/
*            lcpyl(QUOTIENT,lp1);
 LI 7,QUOTIE
 MOV @LP1,8
 BL @FARG#2
 DATA LCPYL
 AI 14,4
*            LDIV(QUOTIENT,L10000);
 LI 7,QUOTIE
 LI 8,L10000
 BL @FARG#2
 DATA LSDIVL
 AI 14,4
*            lgsmod(REMAINDER);
 LI 8,REMAIN
 BL @FARG#1
 DATA LGSMOD
 INCT 14
*            if (REMAINDER[0]<0) ldec(QUOTIENT);
 LI 8,REMAIN
 MOV *8,8
 CI 8,0
 JGT C$33
 JEQ C$33
 LI 8,QUOTIE
 BL @FARG#1
 DATA LDEC
 INCT 14
*            
*/*370 SUM(I-1)=SUM(I-1)+QUOTIENT*/
*            laddl(lp2,QUOTIENT);
C$33
 MOV @LP2,7
 LI 8,QUOTIE
 BL @FARG#2
 DATA LADDL
 AI 14,4
*            
*/*360 SUM(I)=SUM(I)-QUOTIENT*100000*/
*            LMPY(QUOTIENT,L10000);
 LI 7,QUOTIE
 LI 8,L10000
 BL @FARG#2
 DATA LSMPYL
 AI 14,4
*            lsubl(lp1,QUOTIENT);
 MOV @LP1,7
 LI 8,QUOTIE
 BL @FARG#2
 DATA LSUBL
 AI 14,4
*/*380 GOTO 420*/
*        }
*        lp1=lp1-LONGSIZE; lp2=lp2-LONGSIZE;
C$32
 MOV @LP1,8
 AI 8,-4
 MOV 8,@LP1
 MOV @LP2,8
 AI 8,-4
 MOV 8,@LP2
*/*420 NEXT I*/
*    }
 B @C$28
C$29
*/*430 IF FLAG=2 THEN 680*/
*}
 B *13
*
*/* DIVIDE SUBROUTINE */
*
*SubDivide(DENOM) int DENOM;
SUBDIV
*{
*int I;
*
*    lclr(REMAINDER);
 DECT 14
 LI 8,REMAIN
 BL @FARG#1
 DATA LCLR
 INCT 14
*    lcpys(LDENOM,DENOM);
 LI 7,LDENOM
 MOV @6-2(14),8
 BL @FARG#2
 DATA LCPYS
 AI 14,4
*    
*    lp1 = &TERM[1][0];
 LI 8,TERM
 BL 15
 LI 8,1
 LI 7,2
 MPY 8,7
 A 8,8
 A *14+,8
 MOV 8,@LP1
*    for (I=1; I<=D; ++I)
 LI 8,1
 MOV 8,*14
C$37
 MOV *14,8
 C 8,@D
 JLT $+8
 JEQ $+6
 B @C$36
 B @C$38
C$35
 INC *14
 B @C$37
C$38
*    {
*/*      DIVIDEND=REMAINDER*100000+TERM[I];*/
*        lcpyl(DIVIDEND,REMAINDER);
 LI 7,DIVIDE
 LI 8,REMAIN
 BL @FARG#2
 DATA LCPYL
 AI 14,4
*        LMPY(DIVIDEND,L10000);
 LI 7,DIVIDE
 LI 8,L10000
 BL @FARG#2
 DATA LSMPYL
 AI 14,4
*        laddl(DIVIDEND,lp1);
 LI 7,DIVIDE
 MOV @LP1,8
 BL @FARG#2
 DATA LADDL
 AI 14,4
*
*/*      TERM[I]=INT(DIVIDEND/DENOM);*/
*        lcpyl(lp1,DIVIDEND);
 MOV @LP1,7
 LI 8,DIVIDE
 BL @FARG#2
 DATA LCPYL
 AI 14,4
*        LDIV(lp1,LDENOM);
 MOV @LP1,7
 LI 8,LDENOM
 BL @FARG#2
 DATA LSDIVL
 AI 14,4
*lgsmod(REMAINDER);
 LI 8,REMAIN
 BL @FARG#1
 DATA LGSMOD
 INCT 14
*if (REMAINDER[0]<0) ldec(lp1);
 LI 8,REMAIN
 MOV *8,8
 CI 8,0
 JGT C$39
 JEQ C$39
 MOV @LP1,8
 BL @FARG#1
 DATA LDEC
 INCT 14
*
*/*      REMAINDER=DIVIDEND-TERM[I]*DENOM;*/
*        lcpyl(REMAINDER,DIVIDEND);
C$39
 LI 7,REMAIN
 LI 8,DIVIDE
 BL @FARG#2
 DATA LCPYL
 AI 14,4
*/*printf("1 L=%08lX D=%08lX R=%08lX\n",LVAL,DIVIDEND,REMAINDER);*/
*        lcpyl(lval,lp1);
 LI 7,LVAL
 MOV @LP1,8
 BL @FARG#2
 DATA LCPYL
 AI 14,4
*/*printf("2 L=%08lX D=%08lX R=%08lX\n",LVAL,DIVIDEND,REMAINDER);*/
*        LMPY(lval,LDENOM);
 LI 7,LVAL
 LI 8,LDENOM
 BL @FARG#2
 DATA LSMPYL
 AI 14,4
*/*printf("3 L=%08lX D=%08lX R=%08lX\n",LVAL,DIVIDEND,REMAINDER);*/
*        lsubl(REMAINDER,lval);
 LI 7,REMAIN
 LI 8,LVAL
 BL @FARG#2
 DATA LSUBL
 AI 14,4
*/*printf("4 L=%08lX D=%08lX R=%08lX\n",LVAL,DIVIDEND,REMAINDER);*/
*
*/*printf("%d T=%08lX D=%08lX R=%08lX\n",DENOM, lp1,DIVIDEND,REMAINDER);
*waitkey();*/
*        
*        lp1=lp1+LONGSIZE;
 MOV @LP1,8
 AI 8,4
 MOV 8,@LP1
*    }
 B @C$35
C$36
*}
 INCT 14
 B *13
*
*
*/* Output to screen */
*OutScreen()
OUTSCR
*{
*int ix,jx,kx;
*
*    putchar('\f');
 AI 14,-6
 LI 1,12
 BL *12
 DATA XPUTC
*    locate(1,1); puts("Calculations complete!");
 LI 1,1
 LI 0,1
 BL *12
 DATA XLOCAT
 LI 5,C$40
 BL *12
 DATA XPUTS
*
*    locate(3,1); printf("Pi=3.");
 LI 1,3
 LI 0,1
 BL *12
 DATA XLOCAT
 LI 8,C$40+23
 BL @FARG#1
 DATA PRINTF
 INCT 14
*    locate(4,1);
 LI 1,4
 LI 0,1
 BL *12
 DATA XLOCAT
*    for(ix=2, jx=0, kx=4; ix<D; ++ix)
 LI 8,2
 MOV 8,@4(14)
 S 8,8
 MOV 8,@2(14)
 LI 8,4
 MOV 8,*14
C$43
 MOV @4(14),8
 C 8,@D
 JLT $+6
 B @C$42
 B @C$44
C$41
 INC @4(14)
 B @C$43
C$44
*    {
*        printf(" %04lu", &SUM[ix][0]);
 LI 8,C$40+29
 BL 15
 LI 8,SUM
 BL 15
 MOV @8(14),8
 LI 7,2
 MPY 8,7
 A 8,8
 A *14+,8
 BL 15
 BL *12
 DATA PRINTF
 AI 14,4
*        if (++jx>4)
 INC @2(14)
 MOV @2(14),8
 CI 8,4
 JGT $+6
 B @C$45
*        {
*            putchar('\n');
 LI 1,10
 BL *12
 DATA XPUTC
*            jx = 0;
 S 8,8
 MOV 8,@2(14)
*            if (++kx >= 22)
 INC *14
 MOV *14,8
 CI 8,22
 JGT $+8
 JEQ $+6
 B @C$46
*            {
*                locate(24,1); puts("Press any key to continue");
 LI 1,24
 LI 0,1
 BL *12
 DATA XLOCAT
 LI 5,C$40+36
 BL *12
 DATA XPUTS
*                waitkey();
 BL *12
 DATA WAITKE
*                kx=4;
 LI 8,4
 MOV 8,*14
*                clearw(kx,20);
 MOV *14,7
 LI 8,20
 BL @FARG#2
 DATA CLEARW
 AI 14,4
*            }
*        }
C$46
*    }
C$45
 B @C$41
C$42
*    locate(24,1); puts("End. Press any key to exit");
 LI 1,24
 LI 0,1
 BL *12
 DATA XLOCAT
 LI 5,C$40+62
 BL *12
 DATA XPUTS
*    waitkey();
 BL *12
 DATA WAITKE
*}
 AI 14,6
 B *13
C$40 BYTE 67,97,108,99,117,108,97,116,105,111,110,115
 BYTE 32,99,111,109,112,108,101,116,101,33,0,80
 BYTE 105,61,51,46,0,32,37,48,52,108,117,0
 BYTE 80,114,101,115,115,32,97,110,121,32,107,101
 BYTE 121,32,116,111,32,99,111,110,116,105,110,117
 BYTE 101,0,69,110,100,46,32,80,114,101,115,115
 BYTE 32,97,110,121,32,107,101,121,32,116,111,32
 BYTE 101,120,105,116,0
 EVEN
*
*/* test output */
*Out()
OUT
*{
*    Out1("SUM  ", SUM);
 LI 7,C$47
 LI 8,SUM
 BL @FARG#2
 DATA OUT1
 AI 14,4
*    Out1("SUM1 ", SUM1);
 LI 7,C$47+6
 LI 8,SUM1
 BL @FARG#2
 DATA OUT1
 AI 14,4
*    Out1("TERM ", TERM);
 LI 7,C$47+12
 LI 8,TERM
 BL @FARG#2
 DATA OUT1
 AI 14,4
*    Out1("TEMP ", TEMP);
 LI 7,C$47+18
 LI 8,TEMP
 BL @FARG#2
 DATA OUT1
 AI 14,4
*    waitkey();
 BL *12
 DATA WAITKE
*}
 B *13
C$47 BYTE 83,85,77,32,32,0,83,85,77,49,32,0
 BYTE 84,69,82,77,32,0,84,69,77,80,32,0
 EVEN
*
*Out1(n, lp) char *n, *lp;
OUT1
*{
*int ix;
*
*    puts(n);
 DECT 14
 MOV @6(14),5
 BL *12
 DATA XPUTS
*    for(ix=1; ix<=D; ++ix)
 LI 8,1
 MOV 8,*14
C$51
 MOV *14,8
 C 8,@D
 JLT $+8
 JEQ $+6
 B @C$50
 B @C$52
C$49
 INC *14
 B @C$51
C$52
*    {
*         lp=lp+LONGSIZE; printf(" %5ld", lp);
 MOV 14,9
 AI 9,4
 MOV *9,8
 AI 8,4
 MOV 8,*9
 LI 7,C$48
 MOV @6-2(14),8
 BL @FARG#2
 DATA PRINTF
 AI 14,4
*    }
 B @C$49
C$50
*    putchar('\n');
 LI 1,10
 BL *12
 DATA XPUTC
*}
 INCT 14
 B *13
C$48 BYTE 32,37,53,108,100,0
 EVEN
*#ifdef SIGNED
*#asm
*lsmpyl(long1, long2) int *long1, *long2;
*
* unsigned multiply
*
* long1 *= long2 = (LOW(long2) * LOW(long1))            overflow if:
*                + (HOW(long2) * LOW(long1)) 0000       HOW(result)!=0
*                + (LOW(long2) * HOW(long1)) 0000       HOW(result)!=0
*                + (HOW(long2) * HOW(long1)) 0000 0000      result !=0
*
* returns &long1, if overflow occured long1=0xFFFFFFFF 
*
       REF LMPY#S
LSMPYL CLR  0           Sign of the result
       STWP 1
       AI   1,2*6 R1=&R6    
       MOV  @2(8),@2(1) R7=LOW(long2)
       MOV  *8,*1       R6=HOW(long2)
       BL   @LABS$1
       INC  R0          Set sign flag, <>0 means negative
       MOV  @4(14),8    R8=&long1
       MOV  8,1
       MOV  *1,3
       BL   @LABS$1
       DEC  0           Set sign flag, <>0 means negative
       BL   @LMPY#S     Signed multiply
       JMP  LDIV#Q
*
*#asm
* lsdivl(long1, long2) int *long1,*long2;
*
* signed divide
*
* long1 = long1 / long2
* returns &long1
*
* R0   = sign of the result
* R4,5 = long1 / long2
* R2,3 = long1 % long2
*
       REF  LDIV#S
LSDIVL CLR  R0          Sign of the result
       MOV  @2(14),2    R2=&long2
       STWP R1
       AI   1,2*6       R1=&R6
       BL   @LABS$2
       INC  0
LDIV#A MOV  @4(14),2    R2=&long1
       STWP R1
       AI   1,2*8       R1=&R8
       BL   @LABS$2
       DEC  0
       BL   @LDIV#S     Signed divide
LDIV#B MOV  4,*8        R8=&long1
       MOV  5,@2(8)
LDIV#Q MOV  0,1         Must result be negative?
       JEQ  LDIV#C      No!
       MOV  8,1
       BL   @LNEG$
LDIV#C B    *13      
*
*#asm
* lgumod(long) int *long;
* lgsmod(long) int *long;
*
* get unsigned or signed modulo, returns &long;
*
* call the apropriate function directly after
* ldivl() or lsdivl() to retrieve the modulo
* (remainder) of the division.
*
* R1  = sign of the result
* R2,3 = long1 % long2
*
LGUMOD CLR  1        Clear sign flag
LGSMOD MOV  2,*8     R8=&long1
       MOV  3,@2(8)
       MOV  1,1      Must result be negative?
       JEQ  LGSMD#   No!
       MOV  8,1
       BL   @LNEG$
LGSMD# B    *13
*
*#asm
* LABS$2 R1=&long dest, R2=&long src
* LABS$1 R1=&long dest, ST according to HOW(long)
*
* LABS$: if (long<0) abs(long) returns to *R11
*        if (long>=0) returns to R11+2
*
* LNEG$: long = -long returns to *R11
*
LABS$2 MOV  @2(2),@2(1) LOW
       MOV  *2,*1       HOW
LABS$1 JGT  LABS$#      Long>=0
       JEQ  LABS$#
LNEG$  INV *1           /HOW->HOW
       NEG @2(1)        -LOW->LOW
       JNC LNEG$#
       INC *1           HOW+C
LNEG$# B   *11
LABS$# INCT 11
       B   *11
*#endif
 END
