
 Xa99 Cross Assembler
VDP ROUTINES 15/12/2001                                      PAGE 0001
  0001            *
  0002            * VDP access routines 1.0
  0003            *
  0004            * Frederik G. Kaal 15/12/2001
  0005            *
  0007            
  0008                   IDT  'VDP'
  0009            
  0010                   DEF  CVWTR,CVSBR,CVSBW,CVMBR,CVMBW
  0011                   DEF  XVWTR,XVSBW,XVMBR,XVMBW
  0012            
  0013                   REF  VWTR,VSBR,VSBW,VMBR,VMBW
  0014            
  0015            * void cvwtr(vdpreg,byte) int vdpreg,byte;
  0016            *
  0017            * writes byte to VDP register
  0018            *
  0019 0000 C048  CVWTR  MOV  8,1
  0020 0002 C02E         MOV  @4(14),0
       0004 0004 
  0021 0006 0A80  XVWTR  SLA  0,8
  0022 0008 0241         ANDI 1,>00FF
       000A 00FF 
  0023 000C E001         SOC  1,0
  0024 000E 0420         BLWP @VWTR
       0010 0000 
  0025 0012 045D         B    *13
  0026            
  0027            * int cvsbr(vdpadr) int vdpadr
  0028            *
  0029            * reads byte from VDP address
  0030            * returns byte
  0031            *
  0032 0014 C008  CVSBR  MOV  8,0
  0033 0016 0420         BLWP @VSBR
       0018 0000 
  0034 001A C201         MOV  1,8
  0035 001C 0988         SRL  8,8
  0036 001E 045D         B    *13
  0037            
  0038            * void cvsbw(vdpadr,byte) int vdpadr
  0039            *
  0040            * writes byte to VDP address
  0041            *
  0042 0020 C02E  CVSBW  MOV  @4(14),0
       0022 0004 
  0043 0024 C048         MOV  8,1
  0044 0026 06C1  XVSBW  SWPB 1
  0045 0028 0420         BLWP @VSBW
       002A 0000 
  0046 002C 045D         B    *13
  0047            
  0048            * void cvmbr(vdpadr, cpuadr, size) int *vdpadr,*cpuadr,size;
  0049            *
  0050            * reads size bytes from VDP address to CPU address
  0051            *
  0052 002E 06A0  CVMBR  BL    @GCR#   Get registers
       0030 0042'
  0053 0032 0420  XVMBR  BLWP  @VMBR

 Xa99 Cross Assembler
VDP ROUTINES 15/12/2001                                      PAGE 0002
       0034 0000 
  0054 0036 045D         B     *13
  0055            
  0056            * void cvmbw(vdpadr, cpuadr, size) int *vdpadr,*cpuadr,size;
  0057            *
  0058            * writes size bytes from CPU address to VDP address
  0059            *
  0060 0038 06A0  CVMBW  BL    @GCR#   Get registers
       003A 0042'
  0061 003C 0420  XVMBW  BLWP  @VMBW
       003E 0000 
  0062 0040 045D         B     *13
  0063            
  0064 0042 C02E  GCR#   MOV  @6(14),0
       0044 0006 
  0065 0046 C06E         MOV  @4(14),1
       0048 0004 
  0066 004A C088         MOV  8,2
  0067 004C 045B         B    *11
  0068            
  0069                 END

 Xa99 Cross Assembler
VDP ROUTINES 15/12/2001                                      PAGE 0003
  D CVMBR   002E    D CVMBW   0038    D CVSBR   0014    D CVSBW   0020  
  D CVWTR   0000    ' GCR#    0042      R0      0000      R1      0001  
    R10     000A      R11     000B      R12     000C      R13     000D  
    R14     000E      R15     000F      R2      0002      R3      0003  
    R4      0004      R5      0005      R6      0006      R7      0007  
    R8      0008      R9      0009    E VMBR    0034    E VMBW    003E  
  E VSBR    0018    E VSBW    002A    E VWTR    0010    D XVMBR   0032  
  D XVMBW   003C    D XVSBW   0026    D XVWTR   0006  
  0000 ERRORS

 Xa99 Cross Assembler
VDP ROUTINES 15/12/2001                                      PAGE 0004
  SEGMENT RORG     SIZE 00078 (>004E) BYTES
