
 Xa99 Cross Assembler
C99 CSUP V7 - Runtime Library 02/10/2012                     PAGE 0001
  0002            *         TITL 'C99 CSUP V6 - Runtime Library 12/01/2003'
  0003            
  0004                      IDT  'C99CSUP7'
  0005            
  0006            * Copyright 1988 Clint pulley
  0007            *
  0008            * This is the debuged version of the CSUP compiler routines
  0009            * for the TI99/4a
  0010            *
  0011            * Original version: Clint Pulley
  0012            *                   38 Townsend Avenue
  0013            *                   Burlington, Ontario
  0014            *                   Canada L7T 1Y6
  0015            *
  0016            * Updated by:       Frederik G. Kaal
  0017            *                   De Dadelboom 81
  0018            *                   1911 KK Uitgeest
  0019            *                   The Netherlands
  0020            *
  0021            * V6: Additions for the X-optimizer: passing arguments in re
  0022            *     for the funtions: XGETS,XPUTS,XDPUTS,XPUTC,XLOCAT,XPOL
  0023            *
  0024            *
  0025            * Updated by:       Frederik G. Kaal
  0026            *                   Goudsbloem 68
  0027            *                   3984CP Odijk
  0028            *                   The Netherlands
  0029            *
  0030            * V7: Set S$BUFF to 80 for V9938 and F18A 80 column mode
  0031            *     Removed symbols C$SEND,C$STRT
  0032            *     Added symbols ERRNO, CNULL from the now obsolete CGLOB
  0033            *

 Xa99 Cross Assembler
C99 CSUP V7 - Runtime Library 02/10/2012                     PAGE 0002
  0035                   DEF  START,C99STK      Start CSUP and stack
  0036                   DEF  TSCRN,POLL,LOCATE
  0037                   DEF  C$VADR,C$FILL,C$CLS,S$LOC
  0038            *      DEF  C$SEND,C$STRT,S$SEND,S$STRT,S$WDTH,ERRNO,CNULL
  0039                   DEF  S$SEND,S$STRT,S$WDTH,ERRNO,CNULL
  0040                   DEF  C$CALL,C$HOOK,C$SWCH,C$GPLL,C$CTFL
  0041                   DEF  ABORT,EXIT,C$PGRA,C$SGRA,S#DRCT
  0042                   DEF  DPUTS,PUTS,PUTCHA,GETS,GETCHA
  0043                   DEF  C$LNEG,C$CIND,C$REM
  0044                   DEF  C$DIV,C$ASL,C$ASR
  0045                   DEF  C$UGE,C$UGT,C$ULE,C$ULT
  0046                   DEF  C$GE,C$GT,C$LE,C$LT,C$NE,C$EQ
  0047                   DEF  XGETS,XPUTS,XDPUTS,XPUTC,XLOCAT,XPOLL,XTSRCN
  0048            
  0049                   REF  MAIN              User program
  0050            
  0051                   REF  GPLWS
  0052                   REF  GRMRD,GRMWD,GRMRA,GRMWA
  0053                   REF  VDPRD,VDPWD,VDPWA,VDPSTA
  0054                   REF  VWTR,VSBW,VMBW,VSBR,VMBR
  0055                   REF  DSRLNK,XMLLNK,GPLLNK
  0056                   REF  KSCAN,SCAN
  0057            

 Xa99 Cross Assembler
C99 CSUP V7 - Runtime Library 02/10/2012                     PAGE 0003
  0059            
  0060      8300  C99WS  EQU  >8300             C99 Workspace
  0061 0000 3FFE  C99STK DATA >3FFE             C99 Stack
  0062            
  0063      8300  HR0    EQU  C99WS+0
  0064      8301  LR0    EQU  C99WS+1
  0065      8302  HR1    EQU  C99WS+2
  0066      8303  LR1    EQU  C99WS+3
  0067      8304  HR2    EQU  C99WS+4
  0068      8305  LR2    EQU  C99WS+5
  0069      8306  HR3    EQU  C99WS+6
  0070      8307  LR3    EQU  C99WS+7
  0071      8308  HR4    EQU  C99WS+8
  0072      8309  LR4    EQU  C99WS+9
  0073      830A  HR5    EQU  C99WS+10
  0074      830B  LR5    EQU  C99WS+11
  0075      830C  HR6    EQU  C99WS+12
  0076      830D  LR6    EQU  C99WS+13
  0077      830E  HR7    EQU  C99WS+14
  0078      830F  LR7    EQU  C99WS+15
  0079      8310  HR8    EQU  C99WS+16
  0080      8311  LR8    EQU  C99WS+17
  0081      8312  HR9    EQU  C99WS+18
  0082      8313  LR9    EQU  C99WS+19
  0083      8314  HR10   EQU  C99WS+20
  0084      8315  LR10   EQU  C99WS+21
  0085      8316  HR11   EQU  C99WS+22
  0086      8317  LR11   EQU  C99WS+23
  0087      8318  HR12   EQU  C99WS+24
  0088      8319  LR12   EQU  C99WS+25
  0089      831A  HR13   EQU  C99WS+26
  0090      831B  LR13   EQU  C99WS+27
  0091      831C  HR14   EQU  C99WS+28
  0092      831D  LR14   EQU  C99WS+29
  0093      831E  HR15   EQU  C99WS+30
  0094      831F  LR15   EQU  C99WS+31
  0095            

 Xa99 Cross Assembler
C99 CSUP V7 - Runtime Library 02/10/2012                     PAGE 0004
  0097            
  0098            * PUSH
  0099            *
  0100            * Pushes contents R8 on stack
  0101            * Called as: BL R15
  0102            *
  0103 0002 064E  PUSH   DECT  R14
  0104 0004 C788         MOV   R8,*R14
  0105 0006 045B         B     *R11
  0106      0006  PUSHZ  EQU   $-PUSH
  0107            
  0108            * CALL
  0109            * Calls a C written function
  0110            * Called as: BL   *R12
  0111            *            DATA function
  0112            *
  0113 0008 C1FB  CALL   MOV   *R11+,R7
  0114 000A 064E         DECT  R14
  0115 000C C78B         MOV   R11,*R14
  0116 000E 0457         B     *R7
  0117      0008  CALLZ  EQU   $-CALL
  0118            
  0119            * RETURN
  0120            * Returns to calling function
  0121            * Called as: BL *R13
  0122            *
  0123 0010 C1FE  RETURN MOV   *R14+,R7
  0124 0012 0457         B     *R7
  0125      0004  RETRNZ EQU   $-RETURN
  0126            
  0127            * C99 Main startup routine
  0128            
  0129 0014 C80B  START  MOV  R11,@C99RT        Save return address
       0016 009E'
  0130 0018 02E0         LWPI C99WS
       001A 8300 
  0131 001C 06A0         BL   @C$SGRA           Get GROM address
       001E 0110'
  0132 0020 C800         MOV  R0,@C99GRA
       0022 012E'
  0133 0024 04C0         CLR  R0
  0134 0026 04C1         CLR  R1
  0135 0028 06A0         BL   @C$PGRA           Get G0000
       002A 0120'
  0136 002C D060  START1 MOVB @GRMRD,R1
       002E 0000 
  0137 0030 0580         INC  R0
  0138 0032 0280         CI   R0,>17FF          Maximum number of bytes
       0034 17FF 
  0139 0036 1B0C         JH   START3            Yes
  0140            
  0141 0038 0281  START2 CI   R1,>0F00          Is it >07?
       003A 0F00 
  0142 003C 16F7         JNE  START1            No!
  0143 003E D060         MOVB @GRMRD,R1         Read Next
       0040 002E'
  0144 0042 0580         INC  R0
  0145 0044 0281         CI   R1,>F000          Is pattern >07F0
       0046 F000 

 Xa99 Cross Assembler
C99 CSUP V7 - Runtime Library 02/10/2012                     PAGE 0005
  0146 0048 16F7         JNE  START2            No!
  0147 004A 0640         DECT R0                Yes!
  0148 004C C800         MOV  R0,@C99GRB        Save address
       004E 0130'
  0149 0050 06A0  START3 BL   @C$CLS            Clear screen
       0052 043C'
  0150 0054 0200         LI   R0,>01F0          VDP R1=16K-BlankDisable-IntEna
       0056 01F0 
  0151 0058 0420         BLWP @VWTR
       005A 0000 
  0152 005C 06C0         SWPB R0
  0153 005E D800         MOVB R0,@>83D4         Copy to >83D4
       0060 83D4 
  0154 0062 0200         LI   R0,>07F4          VDP R7=White on Blue
       0064 07F4 
  0155 0066 0420         BLWP @VWTR
       0068 005A'
  0156            *
  0157            * Setup R10 as pointer to LSB R8
  0158            * R12 as function call routine
  0159            * R13 as return routine
  0160            * R14 as stack pointer
  0161            * R15 as push routine
  0162            *
  0163 006A 0200         LI   R0,CEXIT1         Push return address
       006C 00A0'
  0164 006E C3A0         MOV  @C99STK,R14       Stack address
       0070 0000'
  0165 0072 C780         MOV  R0,*R14
  0166 0074 02A0         STWP R0
  0167 0076 C280         MOV  R0,R10
  0168 0078 022A         AI   R10,>0011         Lsb R8
       007A 0011 
  0169 007C 0220         AI   R0,>001E          Msb R15 is push routine
       007E 001E 
  0170 0080 C300         MOV  R0,R12
  0171 0082 022C         AI   R12,PUSHZ         Size PUSH routine is start add
       0084 0006 
  0172 0086 C34C         MOV  R12,R13           Start address CALL routine
  0173 0088 022D         AI   R13,CALLZ         Size CALL routine is start add
       008A 0008 
  0174 008C 0201         LI   R1,PUSH
       008E 0002'
  0175 0090 0202         LI   R2,PUSHZ+CALLZ+RETRNZ
       0092 0012 
  0176 0094 CC31  START4 MOV  *R1+,*R0+         Move PUSH, CALL and RETURN to 
  0177 0096 0642         DECT R2
  0178 0098 16FD         JNE  START4
  0179 009A 0460         B    @MAIN             Call user program
       009C 0000 
  0180            
  0181 009E FFFF  C99RT  DATA >FFFF             C99 return address
  0182            
  0183 00A0 0205  CEXIT1 LI   R5,C99T1          puts(C99T1)
       00A2 00F4'
  0184 00A4 069C         BL   *R12
  0185 00A6 02B2'        DATA PUTS1
  0186            
  0187 00A8 C020  CEXIT2 MOV  @C$HOOK,R0        Close files?

 Xa99 Cross Assembler
C99 CSUP V7 - Runtime Library 02/10/2012                     PAGE 0006
       00AA 0540'
  0188 00AC 1301         JEQ  CEXIT3            No!
  0189 00AE 0690         BL   *R0               Yes!
  0190 00B0 0205  CEXIT3 LI   R5,C99T2          puts(C99T2)
       00B2 00FE'
  0191 00B4 069C         BL   *R12
  0192 00B6 02B2'        DATA PUTS1
  0193            
  0194 00B8 06A0  CEXIT4 BL   @RDCHR            Read keyboard
       00BA 034A'
  0195 00BC 0241         ANDI R1,>5F00          Convert to UPC
       00BE 5F00 
  0196 00C0 0281         CI   R1,>5900          Y?
       00C2 5900 
  0197 00C4 13C5         JEQ  START3            Rerun!
  0198 00C6 0281         CI   R1,>4E00          N?
       00C8 4E00 
  0199 00CA 16F6         JNE  CEXIT4            No, read again
  0200            
  0201 00CC 06A0  CEXIT5 BL   @C$CLS            Clear screen
       00CE 043C'
  0202 00D0 04E0         CLR  @>837C            and GPL status
       00D2 837C 
  0203 00D4 0760         ABS  @C$CTFL           EA?
       00D6 010E'
  0204 00D8 1302         JEQ  CEXIT6            Yes!
  0205 00DA 0420         BLWP @>0000            Exit to title screen
       00DC 0000 
  0206            
  0207 00DE C020  CEXIT6 MOV  @C99GRA,R0        Restrore GROM address
       00E0 012E'
  0208 00E2 06A0         BL   @C$PGRA
       00E4 0120'
  0209 00E6 02E0         LWPI GPLWS
       00E8 0000 
  0210 00EA C2E0         MOV  @C99RT,R11
       00EC 009E'
  0211 00EE 0300         LIMI >0002
       00F0 0002 
  0212 00F2 045B         B    *R11              Exit
  0213            
  0214 00F4   0A  C99T1  BYTE 10
  0215 00F5   63         TEXT 'c99 exit'
  0216 00FD   00         BYTE 0
  0217 00FE   2D  C99T2  TEXT '-Rerun? (Y/N) '
  0218 010C 0000         DATA 0
  0219            
  0220 010E 0000  C$CTFL DATA 0                 Console type flag EA, EXBAS?
  0221            
  0222 0110 D020  C$SGRA MOVB @GRMRA,R0         Get Grom address
       0112 0000 
  0223 0114 06C0         SWPB R0
  0224 0116 D020         MOVB @GRMRA,R0
       0118 0112'
  0225 011A 06C0         SWPB R0
  0226 011C 0600         DEC  R0
  0227 011E 045B         B    *R11
  0228            
  0229 0120 D800  C$PGRA MOVB R0,@GRMWA         Put Grom address

 Xa99 Cross Assembler
C99 CSUP V7 - Runtime Library 02/10/2012                     PAGE 0007
       0122 0000 
  0230 0124 06C0         SWPB R0
  0231 0126 D800         MOVB R0,@GRMWA
       0128 0122'
  0232 012A 06C0         SWPB R0
  0233 012C 045B         B    *R11
  0234            
  0235 012E 0000  C99GRA DATA  >0000            Grom address A
  0236 0130 0000  C99GRB DATA  >0000            Grom address B
  0237            
  0238 0132 D020  C$GPLL MOVB @>8373,R0
       0134 8373 
  0239 0136 0980         SRL  R0,8
  0240 0138 0220         AI   R0,HR1
       013A 8302 
  0241 013C C420         MOV  @C99GRB,*R0
       013E 0130'
  0242 0140 06C0         SWPB R0
  0243 0142 D800         MOVB R0,@>8373
       0144 8373 
  0244 0146 C03B         MOV  *R11+,R0          Get routine number
  0245 0148 C04B         MOV  R11,R1            Save return address
  0246 014A 06A0         BL   @C$PGRA           Restore GROM address
       014C 0120'
  0247 014E 0200         LI   R0,C$GPL1         Return address
       0150 015A'
  0248 0152 02E0         LWPI GPLWS
       0154 00E8'
  0249 0156 0460         B    @>006A
       0158 006A 
  0250 015A 02E0  C$GPL1 LWPI C99WS
       015C 8300 
  0251 015E 0451         B    *R1
  0252            
  0253            * C99 Jump instructions
  0254            *
  0255 0160 823E  C$EQ   C     *R14+,R8
  0256 0162 130F         JEQ   C$TRUE
  0257 0164 1011         JMP   C$FALS
  0258            
  0259 0166 823E  C$NE   C     *R14+,R8
  0260 0168 160C         JNE   C$TRUE
  0261 016A 100E         JMP   C$FALS
  0262            
  0263 016C 823E  C$LT   C     *R14+,R8
  0264 016E 1109         JLT   C$TRUE
  0265 0170 100B         JMP   C$FALS
  0266            
  0267 0172 823E  C$LE   C     *R14+,R8
  0268 0174 1509         JGT   C$FALS
  0269 0176 1005         JMP   C$TRUE
  0270            
  0271 0178 823E  C$GT   C     *R14+,R8
  0272 017A 1503         JGT   C$TRUE
  0273 017C 1005         JMP   C$FALS
  0274            
  0275 017E 823E  C$GE   C     *R14+,R8
  0276 0180 1103         JLT   C$FALS
  0277            

 Xa99 Cross Assembler
C99 CSUP V7 - Runtime Library 02/10/2012                     PAGE 0008
  0278 0182 0208  C$TRUE LI    R8,>FFFF
       0184 FFFF 
  0279 0186 045B         B     *R11
  0280            
  0281 0188 6208  C$FALS S     R8,R8
  0282 018A 045B         B     *R11
  0283            
  0284 018C 823E  C$ULT  C     *R14+,R8
  0285 018E 1AF9         JL    C$TRUE
  0286 0190 10FB         JMP   C$FALS
  0287            
  0288 0192 823E  C$ULE  C     *R14+,R8
  0289 0194 12F6         JLE   C$TRUE
  0290 0196 10F8         JMP   C$FALS
  0291            
  0292 0198 823E  C$UGT  C     *R14+,R8
  0293 019A 1BF3         JH    C$TRUE
  0294 019C 10F5         JMP   C$FALS
  0295            
  0296 019E 823E  C$UGE  C     *R14+,R8
  0297 01A0 14F0         JHE   C$TRUE
  0298 01A2 10F2         JMP   C$FALS
  0299            

 Xa99 Cross Assembler
C99 CSUP V7 - Runtime Library 02/10/2012                     PAGE 0009
  0301            * C99 Shift instructions
  0302            *
  0303 01A4 C008  C$ASR  MOV   R8,R0
  0304 01A6 C23E         MOV   *R14+,R8
  0305 01A8 0808         SRA   R8,0
  0306 01AA 045B         B     *R11
  0307            
  0308 01AC C008  C$ASL  MOV   R8,R0
  0309 01AE C23E         MOV   *R14+,R8
  0310 01B0 0A08         SLA   R8,0
  0311 01B2 045B         B     *R11
  0312            
  0313            * C99 Divide and Module instructions
  0314            *
  0315 01B4 C1CB  C$DIV  MOV   R11,R7
  0316 01B6 06A0         BL    @DIVIDE
       01B8 01C8'
  0317 01BA C200         MOV   R0,R8            Quotient
  0318 01BC 0457         B     *R7
  0319            
  0320 01BE C1CB  C$REM  MOV   R11,R7
  0321 01C0 06A0         BL    @DIVIDE
       01C2 01C8'
  0322 01C4 C201         MOV   R1,R8            Remainder
  0323 01C6 0457         B     *R7
  0324            
  0325            * R0,R1 / R2 --> R0 = Quotient, R1 = Remainder
  0326            *
  0327 01C8 04C0  DIVIDE CLR   R0               Most Significant word
  0328 01CA C27E         MOV   *R14+,R9
  0329 01CC C049         MOV   R9,R1            Least Significant word
  0330 01CE 0741         ABS   R1
  0331 01D0 C088         MOV   R8,R2            Divider
  0332 01D2 130A         JEQ   DIVID3           Divide by zero!
  0333 01D4 0742         ABS   R2
  0334 01D6 3C02         DIV   R2,R0
  0335 01D8 C208         MOV   R8,R8
  0336 01DA 1501         JGT   DIVID1
  0337 01DC 0500         NEG   R0
  0338 01DE C249  DIVID1 MOV   R9,R9
  0339 01E0 1502         JGT   DIVID2
  0340 01E2 0500         NEG   R0
  0341 01E4 0501         NEG   R1
  0342 01E6 045B  DIVID2 B     *R11
  0343            
  0344 01E8 04C1  DIVID3 CLR   R1                R0=R1=0 Divide by zero
  0345 01EA 045B         B     *R11
  0346            
  0347            * Indirect function call
  0348            * Called as: LI  R8,function address
  0349            *            MOV R8,@C$CALL
  0350            *            BL  C$IND
  0351            *
  0352 01EC 064E  C$CIND DECT  R14              Save program counter
  0353 01EE C78B         MOV   R11,*R14
  0354 01F0 C1E0         MOV   @C$CALL,R7       Statement address
       01F2 01F6'
  0355 01F4 0457         B     *R7              Execute Statement
  0356            

 Xa99 Cross Assembler
C99 CSUP V7 - Runtime Library 02/10/2012                     PAGE 0010
  0357 01F6       C$CALL BSS   2
  0358            
  0359            * Negate
  0360            * 0000 --> FFFF
  0361            * xxxx --> 0000
  0362            *
  0363 01F8 C208  C$LNEG MOV   R8,R8
  0364 01FA 1302         JEQ   C$LNG1
  0365 01FC 6208         S     R8,R8
  0366 01FE 045B         B     *R11
  0367 0200 0608  C$LNG1 DEC   R8
  0368 0202 045B         B     *R11
  0369            
  0370            * Switch statement
  0371            * Called as:      B    @C$2
  0372            *            C$3  case statements
  0373            *            C$4  case statements
  0374            *            C$5  default statements
  0375            *                 B    @C$3 exit switch
  0376            *
  0377            *           C$2   BL   @C$SWCH
  0378            *                 DATA C$3,value
  0379            *                 DATA C$4,value
  0380            *                 DATA 0
  0381            *                 B    C$5 do default
  0382            *           C$1   Every break jumps here
  0383            *
  0384 0204 C03B  C$SWCH MOV   *R11+,R0         Statament adres
  0385 0206 1303         JEQ   C$SWC1           End of list
  0386 0208 823B         C     *R11+,R8         This Switch TRUE?
  0387 020A 16FC         JNE   C$SWCH           No!
  0388 020C 0450         B     *R0              Execute case Statement
  0389 020E 045B  C$SWC1 B     *R11             Do default statement
  0390            
  0391            * c = GETCHAR()
  0392            *
  0393            * Wait for a key to be pressed and returns the
  0394            * character value. The character is egoed to
  0395            * the screen. If the character is ENTER the
  0396            * screen spaces to the start of a new line and
  0397            * a value of 10 is returned. If the character is
  0398            * Ctrl-z, a value of -1 is returned.
  0399            *
  0400 0210 06A0  GETCHA BL   @RDCHR            Read keyboard
       0212 034A'
  0401 0214 C201         MOV  R1,R8             Return value
  0402 0216 0988         SRL  R8,8
  0403 0218 0241         ANDI R1,>7F00          c>=' '
       021A 7F00 
  0404 021C 0281         CI   R1,>2000
       021E 2000 
  0405 0220 1A03         JL   GETCH2            No!
  0406 0222 06A0         BL   @WRCHR            Yes, echo
       0224 03A0'
  0407 0226 045D         B    *R13
  0408            
  0409 0228 0281  GETCH2 CI   R1,>0D00          c=enter?
       022A 0D00 
  0410 022C 1607         JNE  GETCH5            No!

 Xa99 Cross Assembler
C99 CSUP V7 - Runtime Library 02/10/2012                     PAGE 0011
  0411 022E 0208         LI   R8,>000A          Yes return 10
       0230 000A 
  0412 0232 0201  GETCH3 LI   R1,>0A00
       0234 0A00 
  0413 0236 06A0         BL   @WRCHR            echo
       0238 03A0'
  0414 023A 045D  GETCH4 B    *R13
  0415            
  0416 023C 0281  GETCH5 CI   R1,>1A00          c=Ctrl-z
       023E 1A00 
  0417 0240 16FC         JNE  GETCH4            No!
  0418 0242 0708         SETO R8                Yes return -1
  0419 0244 10F6         JMP  GETCH3            Echo
  0420            
  0421            * c=GETS(buff)
  0422            *
  0423            * Read one line from the keyboard to a character
  0424            * array. The line is terminated with Enter, Cltr-z
  0425            * or the 80th character. The array is assumed to be
  0426            * 81 characters long and a null (0) character is
  0427            * appended to the end of the string. A value of buff
  0428            * is returned unless Ctrl-z is pressed. In that case
  0429            * a null is returned. Use of the backspace key (Fctn-s)
  0430            * for inline editing is supported.
  0431            
  0432 0246 C16E  GETS   MOV  @>2(R14),R5       Get &buff
       0248 0002 
  0433 024A 0204  XGETS  LI   R4,>0050          Max characters
       024C 0050 
  0434 024E C205         MOV  R5,R8             Return value
  0435 0250 06A0  GETS1  BL   @RDCHR            Read a character
       0252 034A'
  0436 0254 0281         CI   R1,>0D00          Is it Enter
       0256 0D00 
  0437 0258 1315         JEQ  GETS4             Yes
  0438 025A 0281         CI   R1,>9A00          Is it Ctrl-z
       025C 9A00 
  0439 025E 1602         JNE  GETS2             No
  0440 0260 04C8         CLR  R8                Return null
  0441 0262 1010         JMP  GETS4
  0442 0264 0281  GETS2  CI   R1,>0800          Is it BS
       0266 0800 
  0443 0268 1608         JNE  GETS3             No
  0444 026A 0284         CI   R4,>0050          First Character
       026C 0050 
  0445 026E 13F0         JEQ  GETS1             Yes
  0446 0270 0584         INC  R4                Loose character
  0447 0272 0605         DEC  R5
  0448 0274 06A0         BL   @WRCHR            Echo
       0276 03A0'
  0449 0278 10EB         JMP  GETS1             Again
  0450 027A DD41  GETS3  MOVB R1,*R5+           Store character
  0451 027C 06A0         BL   @WRCHR            Echo
       027E 03A0'
  0452 0280 0604         DEC  R4                More characters
  0453 0282 16E6         JNE  GETS1             Yes
  0454 0284 0201  GETS4  LI   R1,>000A          Terminate string
       0286 000A 
  0455 0288 D541         MOVB R1,*R5

 Xa99 Cross Assembler
C99 CSUP V7 - Runtime Library 02/10/2012                     PAGE 0012
  0456 028A 06C1         SWPB R1                Echo LF
  0457 028C 06A0         BL   @WRCHR
       028E 03A0'
  0458 0290 045D         B    *R13
  0459            
  0460            
  0461            * c=PUTCHAR(c)
  0462            *
  0463            * Writes the character whose ascii value is c to the
  0464            * screen. If c==10 (eol) the screen spaces to the start
  0465            * of a new line. If c==8 (BS) the cursor is backspaced.
  0466            * if c==12 (FF) the screen is cleared and the cursor is
  0467            * homed. If c represents a non printing character, a \
  0468            * is echoed. The value of c is returned.
  0469            *
  0470 0292 C06E  PUTCHA MOV  @>2(R14),R1       Get character
       0294 0002 
  0471 0296 C201  XPUTC  MOV  R1,R8             Return value
  0472 0298 06C1         SWPB R1
  0473 029A 06A0         BL   @WRCHR            Echo
       029C 03A0'
  0474 029E 045D         B    *R13
  0475            
  0476            * PUTS(string)
  0477            *
  0478            * Writes a string to the screen, stopping when
  0479            * it finds a null (0) character. The null
  0480            * character is not written. The cursor is not
  0481            * spaced to the start of a newline unless
  0482            * newline (\n) is encountered.
  0483            *
  0484 02A0 C060  XPUTS  MOV  @S#DRCT,R1
       02A2 033C'
  0485 02A4 160E         JNE  XDPUTS
  0486 02A6 1005         JMP  PUTS1
  0487            
  0488 02A8 C16E  PUTS   MOV  @2(R14),R5        Get string address
       02AA 0002 
  0489 02AC C060         MOV  @S#DRCT,R1        Direct video
       02AE 033C'
  0490 02B0 1606         JNE  DPUTS
  0491 02B2 D075  PUTS1  MOVB *R5+,R1           Get character
  0492 02B4 1303         JEQ  PUTS2             End of string
  0493 02B6 06A0         BL   @WRCHR            Echo
       02B8 03A0'
  0494 02BA 10FB         JMP  PUTS1             Next
  0495 02BC 045D  PUTS2  B    *R13
  0496            
  0497 02BE C16E  DPUTS  MOV  @2(R14),R5        Get string address
       02C0 0002 
  0498 02C2 04E0  XDPUTS CLR  @S#DRCT
       02C4 033C'
  0499 02C6 0201         LI   R1,>4000          Set VDP location
       02C8 4000 
  0500 02CA E060         SOC  @S$LOC,R1
       02CC 033E'
  0501 02CE 06C1         SWPB R1
  0502 02D0 D801         MOVB R1,@VDPWA
       02D2 0000 

 Xa99 Cross Assembler
C99 CSUP V7 - Runtime Library 02/10/2012                     PAGE 0013
  0503 02D4 06C1         SWPB R1
  0504 02D6 D801         MOVB R1,@VDPWA
       02D8 02D2'
  0505 02DA D075  DPUTS1 MOVB *R5+,R1           Write string
  0506 02DC 1305         JEQ  DPUTSX
  0507 02DE D801         MOVB R1,@VDPWD
       02E0 0000 
  0508 02E2 05A0         INC  @S$LOC
       02E4 033E'
  0509 02E6 10F9         JMP  DPUTS1
  0510 02E8 045D  DPUTSX B    *13
  0511            
  0512 02EA       S$BUFF BSS  80       Scroll buffer
  0513 033A 0000  S$CHAR DATA 0        Screen character
  0514 033C 0000  S#DRCT DATA 0        Direct video
  0515 033E 0000  S$LOC  DATA 0        Cursor location
  0516 0340 0028  S$WDTH DATA 40       Screen width
  0517 0342 0000  S$STRT DATA 0        Screen start
  0518 0344 03C0  S$SEND DATA 40*24    Screen end
  0519            *C$STRT DATA 0        Screen start
  0520            *C$SEND DATA 40*24    Screen end
  0521 0346 0000  ERRNO  DATA 0        Error number
  0522 0348 0000  CNULL  DATA 0        Constant byte/word NULL
  0523            
  0524            * RDCHR
  0525            *
  0526            * Read a character, display a cursor
  0527            * result in R1
  0528            *
  0529 034A 0207  RDCHR  LI   R7,>00C7          Cursor timer
       034C 00C7 
  0530 034E C020         MOV  @S$LOC,R0         Read character
       0350 033E'
  0531 0352 0420         BLWP @VSBR
       0354 0000 
  0532 0356 D801         MOVB R1,@S$CHAR        Save it
       0358 033A'
  0533 035A 0587  RDCHR1 INC  R7
  0534 035C 0420         BLWP @KSCAN            Scan key board
       035E 0000 
  0535 0360 C0A0         MOV  @>837C,R2         New key pressed
       0362 837C 
  0536 0364 0242         ANDI R2,>2000
       0366 2000 
  0537 0368 1613         JNE  RDCHR5            Yes
  0538 036A 0287         CI   R7,>0064          Cursor swap
       036C 0064 
  0539 036E 1603         JNE  RDCHR2            No
  0540 0370 D060         MOVB @S$CHAR,R1        Get screen character
       0372 033A'
  0541 0374 1006         JMP  RDCHR3            Write back
  0542 0376 0287  RDCHR2 CI   R7,>00C8          Display cursor?
       0378 00C8 
  0543 037A 1605         JNE  RDCHR4            No
  0544 037C 04C7         CLR  R7                Yes
  0545 037E 0201         LI   R1,>5F20          Cursor '_ '
       0380 5F20 
  0546 0382 0420  RDCHR3 BLWP @VSBW             Write cursor or character
       0384 0000 

 Xa99 Cross Assembler
C99 CSUP V7 - Runtime Library 02/10/2012                     PAGE 0014
  0547 0386 0300  RDCHR4 LIMI >0002
       0388 0002 
  0548 038A 0300         LIMI >0000
       038C 0000 
  0549 038E 10E5         JMP  RDCHR1
  0550 0390 D060  RDCHR5 MOVB @S$CHAR,R1        Restore screen character
       0392 033A'
  0551 0394 0420         BLWP @VSBW
       0396 0384'
  0552 0398 04C1         CLR  R1
  0553 039A D060         MOVB @>8375,R1         Get key code
       039C 8375 
  0554 039E 045B         B    *R11
  0555            
  0556            
  0557            * WRCHR
  0558            *
  0559            * Write a character to the screen
  0560            * and take actions for BS, CR, LF and FF
  0561            *
  0562 03A0 0241  WRCHR  ANDI R1,>7F00
       03A2 7F00 
  0563 03A4 0281  WRCHBS CI   R1,>0800          BackSpace
       03A6 0800 
  0564 03A8 160C         JNE  WRCHLF            No
  0565 03AA 0201         LI   R1,>2020          '  '
       03AC 2020 
  0566 03AE C020         MOV  @S$LOC,R0         VDP location
       03B0 033E'
  0567 03B2 0420         BLWP @VSBW
       03B4 0396'
  0568 03B6 8800         C    R0,@S$STRT        First location
       03B8 0342'
  0569 03BA 1202         JLE  WRCHEX            Yes
  0570 03BC 0620         DEC  @S$LOC            Previous location
       03BE 033E'
  0571 03C0 045B  WRCHEX B    *R11
  0572            
  0573 03C2 0281  WRCHLF CI   R1,>0A00          LineFeed
       03C4 0A00 
  0574 03C6 1627         JNE  WRCHCR            No
  0575 03C8 C1E0         MOV  @S$SEND,R7        Past end of screen
       03CA 0344'
  0576 03CC 61E0         S    @S$WDTH,R7
       03CE 0340'
  0577 03D0 81E0         C    @S$LOC,R7
       03D2 033E'
  0578 03D4 1404         JHE  SCROLL            Yes
  0579 03D6 A820         A    @S$WDTH,@S$LOC    Next line
       03D8 0340'
       03DA 033E'
  0580 03DC 101F         JMP  WRCCR1
  0581            
  0582 03DE C020  SCROLL MOV  @S$STRT,R0        Start of screen
       03E0 0342'
  0583 03E2 0201         LI   R1,S$BUFF
       03E4 02EA'
  0584 03E6 C0A0         MOV  @S$WDTH,R2        Screen width
       03E8 0340'

 Xa99 Cross Assembler
C99 CSUP V7 - Runtime Library 02/10/2012                     PAGE 0015
  0585 03EA A002         A    R2,R0             Next line
  0586 03EC 0420  SCRLL1 BLWP @VMBR
       03EE 0000 
  0587 03F0 6002         S    R2,R0             Previous line
  0588 03F2 0420         BLWP @VMBW
       03F4 0000 
  0589 03F6 A002         A    R2,R0             Calculate next line
  0590 03F8 A002         A    R2,R0
  0591 03FA 8800         C    R0,@S$SEND        Past end of screen
       03FC 0344'
  0592 03FE 1AF6         JL   SCRLL1            No
  0593 0400 C042         MOV  R2,R1             Number of characters to clear
  0594 0402 0200         LI   R0,>2020          with spaces
       0404 2020 
  0595 0406 60A0         S    @S$SEND,R2        Calculate last line address
       0408 0344'
  0596 040A 0502         NEG  R2
  0597 040C C1CB         MOV  R11,R7            Save return address
  0598 040E 06A0         BL   @C$FILL           Clear line
       0410 0476'
  0599 0412 C2C7         MOV  R7,R11
  0600 0414 1003         JMP  WRCCR1
  0601            
  0602 0416 0281  WRCHCR CI   R1,>0D00          CariageReturn
       0418 0D00 
  0603 041A 160D         JNE  WRCHFF            No
  0604 041C 04C0  WRCCR1 CLR  R0                Calculate start address of lin
  0605 041E C060         MOV  @S$LOC,R1
       0420 033E'
  0606 0422 C0C1         MOV  R1,R3
  0607 0424 6060         S    @S$STRT,R1
       0426 0342'
  0608 0428 C0A0         MOV  @S$WDTH,R2
       042A 0340'
  0609 042C 3C02         DIV  R2,R0
  0610 042E 60C1         S    R1,R3
  0611 0430 C803         MOV  R3,@S$LOC
       0432 033E'
  0612 0434 045B         B    *R11
  0613            
  0614 0436 0281  WRCHFF CI   R1,>0C00          FormFeed
       0438 0C00 
  0615 043A 160B         JNE  WRCHC             No
  0616 043C C0A0  C$CLS  MOV  @S$STRT,R2        Start on top
       043E 0342'
  0617 0440 C802         MOV  R2,@S$LOC
       0442 033E'
  0618 0444 C060         MOV  @S$SEND,R1        Number of bytes on screen
       0446 0344'
  0619 0448 6042         S    R2,R1
  0620 044A 0200         LI   R0,>2020          Fill with spaces
       044C 2020 
  0621 044E 0460         B    @C$FILL           Clear screen and return
       0450 0476'
  0622            
  0623 0452 0281  WRCHC  CI   R1,>1F00          Character >=' '
       0454 1F00 
  0624 0456 1B02         JH   WRCC1             Yes
  0625 0458 0201         LI   R1,>5C20

 Xa99 Cross Assembler
C99 CSUP V7 - Runtime Library 02/10/2012                     PAGE 0016
       045A 5C20 
  0626 045C C020  WRCC1  MOV  @S$LOC,R0
       045E 033E'
  0627 0460 0420         BLWP @VSBW
       0462 03B4'
  0628 0464 C0A0         MOV  @S$SEND,R2        Reached end of screen
       0466 0344'
  0629 0468 0602         DEC  R2
  0630 046A 8080         C    R0,R2
  0631 046C 14B8         JHE  SCROLL            Yes
  0632 046E 0580         INC  R0                Next location
  0633 0470 C800         MOV  R0,@S$LOC
       0472 033E'
  0634 0474 045B         B    *R11
  0635            
  0636            * C$FILL
  0637            *
  0638            * Fill screen locations, start addres in R2
  0639            * and count in R1, with the character in R0
  0640            *
  0641 0476 0262  C$FILL ORI  R2,>4000          Vdp address
       0478 4000 
  0642 047A 06C2         SWPB R2
  0643 047C D802         MOVB R2,@VDPWA
       047E 02D8'
  0644 0480 06C2         SWPB R2
  0645 0482 D802         MOVB R2,@VDPWA
       0484 047E'
  0646 0486 1000         NOP
  0647 0488 D800  C$FIL1 MOVB R0,@VDPWD         Write character
       048A 02E0'
  0648 048C 0601         DEC  R1                More to write
  0649 048E 16FC         JNE  C$FIL1            Yes
  0650 0490 045B         B    *R11
  0651            
  0652            * LOCATE(row,col)
  0653            *
  0654            * Places the cursor at the screen location specified
  0655            * by row and col. Subsequent console I/O will start
  0656            * at the new cursor location. Row and Column numbering
  0657            * starts with 1 and the validity is not checked.
  0658            *
  0659 0492 C02E  LOCATE MOV  @>2(R14),R0     Get Col
       0494 0002 
  0660 0496 C06E         MOV  @>4(R14),R1     Get Row
       0498 0004 
  0661 049A 06A0  XLOCAT BL   @C$VADR         Calculate VDP address
       049C 04F4'
  0662 049E C800         MOV  R0,@S$LOC       Save screen location
       04A0 033E'
  0663 04A2 045D         B    *R13
  0664            
  0665            * key=POLL(c)
  0666            *
  0667            * Scans the keyboard and returns the key value
  0668            * if one is pressed or 0. If c!=0 the program
  0669            * will pause while a key is down. If c!=0 and
  0670            * Fctn-4 is pressed (CLEAR) the program will
  0671            * branch to the c99 exit function.

 Xa99 Cross Assembler
C99 CSUP V7 - Runtime Library 02/10/2012                     PAGE 0017
  0672            *
  0673 04A4 C0EE  POLL   MOV  @>2(R14),R3       Get c
       04A6 0002 
  0674 04A8 0300  XPOLL  LIMI >0002
       04AA 0002 
  0675 04AC 0300         LIMI >0000
       04AE 0000 
  0676 04B0 0420  POLL1  BLWP @KSCAN            Read keyboard
       04B2 035E'
  0677 04B4 D220         MOVB @>8375,R8         Get key code
       04B6 8375 
  0678 04B8 0988         SRL  R8,8
  0679 04BA 0288         CI   R8,>00FF          Key pressed
       04BC 00FF 
  0680 04BE 1602         JNE  POLL3             Yes
  0681 04C0 04C8         CLR  R8                No
  0682 04C2 045D  POLL2  B    *R13
  0683 04C4 C0C3  POLL3  MOV  R3,R3             Wait?
  0684 04C6 13FD         JEQ  POLL2             No
  0685 04C8 0288         CI   R8,>0002          Fctn-4
       04CA 0002 
  0686 04CC 16F1         JNE  POLL1             No
  0687 04CE 0460         B    @CEXIT1           Yes
       04D0 00A0'
  0688            
  0689            * TSCRN(f,b)
  0690            *
  0691            * Changes the text mode screen color to f (foreground)
  0692            * and b (background). The basic color numbering convention
  0693            * is used.
  0694            *
  0695 04D2 C02E  TSCRN  MOV   @>2(R14),R0      Background color
       04D4 0002 
  0696 04D6 C06E         MOV   @>4(R14),R1      Foreground color
       04D8 0004 
  0697 04DA 0600  XTSRCN DEC   R0
  0698 04DC 0240         ANDI  R0,>000F
       04DE 000F 
  0699 04E0 0601         DEC   R1
  0700 04E2 0241         ANDI  R1,>000F
       04E4 000F 
  0701 04E6 0A41         SLA   R1,4
  0702 04E8 E001         SOC   R1,R0
  0703 04EA 0220         AI    R0,>0700         VDP register 7
       04EC 0700 
  0704 04EE 0420         BLWP  @VWTR
       04F0 0068'
  0705 04F2 045D         B     *R13
  0706            
  0707            * C$VADR
  0708            *
  0709            * Calculate VDP screen address from Row (R1)
  0710            * and Column (R0)
  0711            *
  0712 04F4 0600  C$VADR DEC   R0               Column-1
  0713 04F6 0601         DEC   R1               Row-1
  0714 04F8 3860         MPY   @S$WDTH,R1       Row * Screen Width
       04FA 0340'
  0715 04FC A002         A     R2,R0            + Column

 Xa99 Cross Assembler
C99 CSUP V7 - Runtime Library 02/10/2012                     PAGE 0018
  0716 04FE A020         A     @S$STRT,R0       + Screen start address
       0500 0342'
  0717            *      A     @C$STRT,R0       + Screen start address
  0718 0502 045B         B     *R11
  0719            
  0720            * EXIT(c) or ABORT(c)
  0721            *
  0722            * Branches to the c99 exit function which closes
  0723            * any open files. The value of c may be between
  0724            * 0 and 7. if c==0 the normal exit message is
  0725            * displayed. if c==7 the program terminates
  0726            * immediately. Otherwise the vvalue of c is
  0727            * displayed in an error message. The exit(0)
  0728            * function is also executed when function main()
  0729            * terminates normally.
  0730            *
  0731            EXIT
  0732 0504 C02E  ABORT  MOV  @2(R14),R0        Get exit value
       0506 0002 
  0733 0508 1602         JNE  ABORT1            >0
  0734 050A 0460         B    @CEXIT1
       050C 00A0'
  0735 050E 0240  ABORT1 ANDI R0,>0007          Only exit codes 1-7
       0510 0007 
  0736 0512 0280         CI   R0,>0007          Is it 7, terminate immediatell
       0514 0007 
  0737 0516 1602         JNE  ABORT2            No
  0738 0518 0460         B    @CEXIT5           Terminate immediatelly
       051A 00CC'
  0739            
  0740 051C 0220  ABORT2 AI   R0,>0030          Make value 1-6
       051E 0030 
  0741 0520 06C0         SWPB R0
  0742 0522 D800         MOVB R0,@C99T3X
       0524 053D'
  0743 0526 0208         LI   R8,C99T3          puts(C99T3)
       0528 0534'
  0744 052A 068F         BL   R15
  0745 052C 069C         BL   *R12
  0746 052E 02A8'        DATA PUTS
  0747 0530 0460         B    @CEXIT2
       0532 00A8'
  0748            
  0749 0534   0A  C99T3  BYTE  10
  0750 0535   63         TEXT  'c99 err='
  0751 053D   58  C99T3X BYTE  'X'
  0752 053E 0000         DATA  >0000
  0753 0540 0000  C$HOOK DATA  >0000
  0754                   END

 Xa99 Cross Assembler
C99 CSUP V7 - Runtime Library 02/10/2012                     PAGE 0019
  D ABORT   0504    ' ABORT1  050E    ' ABORT2  051C    D C$ASL   01AC  
  D C$ASR   01A4    D C$CALL  01F6    D C$CIND  01EC    D C$CLS   043C  
  D C$CTFL  010E    D C$DIV   01B4    D C$EQ    0160    ' C$FALS  0188  
  ' C$FIL1  0488    D C$FILL  0476    D C$GE    017E    ' C$GPL1  015A  
  D C$GPLL  0132    D C$GT    0178    D C$HOOK  0540    D C$LE    0172  
  D C$LNEG  01F8    ' C$LNG1  0200    D C$LT    016C    D C$NE    0166  
  D C$PGRA  0120    D C$REM   01BE    D C$SGRA  0110    ' C$SWC1  020E  
  D C$SWCH  0204    ' C$TRUE  0182    D C$UGE   019E    D C$UGT   0198  
  D C$ULE   0192    D C$ULT   018C    D C$VADR  04F4    ' C99GRA  012E  
  ' C99GRB  0130    ' C99RT   009E    D C99STK  0000    ' C99T1   00F4  
  ' C99T2   00FE    ' C99T3   0534    ' C99T3X  053D      C99WS   8300  
  ' CALL    0008      CALLZ   0008    ' CEXIT1  00A0    ' CEXIT2  00A8  
  ' CEXIT3  00B0    ' CEXIT4  00B8    ' CEXIT5  00CC    ' CEXIT6  00DE  
  D CNULL   0348    ' DIVID1  01DE    ' DIVID2  01E6    ' DIVID3  01E8  
  ' DIVIDE  01C8    D DPUTS   02BE    ' DPUTS1  02DA    ' DPUTSX  02E8  
  E DSRLNK  0000    D ERRNO   0346    D EXIT    0504    ' GETCH2  0228  
  ' GETCH3  0232    ' GETCH4  023A    ' GETCH5  023C    D GETCHA  0210  
  D GETS    0246    ' GETS1   0250    ' GETS2   0264    ' GETS3   027A  
  ' GETS4   0284    E GPLLNK  0000    E GPLWS   0154    E GRMRA   0118  
  E GRMRD   0040    E GRMWA   0128    E GRMWD   0000      HR0     8300  
    HR1     8302      HR10    8314      HR11    8316      HR12    8318  
    HR13    831A      HR14    831C      HR15    831E      HR2     8304  
    HR3     8306      HR4     8308      HR5     830A      HR6     830C  
    HR7     830E      HR8     8310      HR9     8312    E KSCAN   04B2  
  D LOCATE  0492      LR0     8301      LR1     8303      LR10    8315  
    LR11    8317      LR12    8319      LR13    831B      LR14    831D  
    LR15    831F      LR2     8305      LR3     8307      LR4     8309  
    LR5     830B      LR6     830D      LR7     830F      LR8     8311  
    LR9     8313    E MAIN    009C    D POLL    04A4    ' POLL1   04B0  
  ' POLL2   04C2    ' POLL3   04C4    ' PUSH    0002      PUSHZ   0006  
  D PUTCHA  0292    D PUTS    02A8    ' PUTS1   02B2    ' PUTS2   02BC  
    R0      0000      R1      0001      R10     000A      R11     000B  
    R12     000C      R13     000D      R14     000E      R15     000F  
    R2      0002      R3      0003      R4      0004      R5      0005  
    R6      0006      R7      0007      R8      0008      R9      0009  
  ' RDCHR   034A    ' RDCHR1  035A    ' RDCHR2  0376    ' RDCHR3  0382  
  ' RDCHR4  0386    ' RDCHR5  0390      RETRNZ  0004    ' RETURN  0010  
  D S#DRCT  033C    ' S$BUFF  02EA    ' S$CHAR  033A    D S$LOC   033E  
  D S$SEND  0344    D S$STRT  0342    D S$WDTH  0340    E SCAN    0000  
  ' SCRLL1  03EC    ' SCROLL  03DE    D START   0014    ' START1  002C  
  ' START2  0038    ' START3  0050    ' START4  0094    D TSCRN   04D2  
  E VDPRD   0000    E VDPSTA  0000    E VDPWA   0484    E VDPWD   048A  
  E VMBR    03EE    E VMBW    03F4    E VSBR    0354    E VSBW    0462  
  E VWTR    04F0    ' WRCC1   045C    ' WRCCR1  041C    ' WRCHBS  03A4  
  ' WRCHC   0452    ' WRCHCR  0416    ' WRCHEX  03C0    ' WRCHFF  0436  
  ' WRCHLF  03C2    ' WRCHR   03A0    D XDPUTS  02C2    D XGETS   024A  
  D XLOCAT  049A    E XMLLNK  0000    D XPOLL   04A8    D XPUTC   0296  
  D XPUTS   02A0    D XTSRCN  04DA  
  0000 ERRORS

 Xa99 Cross Assembler
C99 CSUP V7 - Runtime Library 02/10/2012                     PAGE 0020
  SEGMENT RORG     SIZE 01346 (>0542) BYTES
